Index: EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/componentobj.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/componentobj.rb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/componentobj.rb	(revision 429)
@@ -6823,4 +7438,7 @@
     }
 
+    header_path = find_file header
+
+=begin
     include_opt = ""
     found = false
@@ -6844,7 +7462,19 @@
 
     if found == false then
+=end
+    if header_path == nil then
       cdl_error( "S1142 $1 not found in search path" , header )
       return
     end
+
+    include_opt = ""
+    if get_base_dir then
+      base = get_base_dir + "/"
+    else
+      base = ""
+    end
+    $import_path.each{ |path|
+      include_opt = "#{include_opt} -I #{base}#{path}"
+    }
 
     # 読込み済み？
@@ -6862,4 +7492,8 @@
     @@header_list2 << header
     @@define_list[ header ] = define
+
+    if $verbose then
+      print "import_C header=#{header_path}, define=#{define}\n"
+    end
 
     begin
@@ -6940,4 +7574,6 @@
  * --no-gcc-extension-support for tecsgen.
  */
+#ifdef __GNUC__
+
 #ifndef __attribute__
 #define __attribute__(x)
@@ -6956,4 +7592,9 @@
 #endif
 
+#ifndef restrict
+#define restrict
+#endif
+
+#endif /* ifdef __GNUC__ */
 #endif /* TECS_NO_GCC_EXTENSION_SUPPORT */
 EOT
@@ -6983,4 +7624,6 @@
 # @cdl_path:: string:   CDL のパス
 # @b_imported:: bool:   import された(コマンドライン指定されていない)
+
+  include Importable
 
   # ヘッダの名前文字列のリスト  添字：expand したパス、値：Import
@@ -7023,34 +7666,14 @@
     @b_reuse_real = @b_reuse || Generator.is_reuse?
 
-    if Generator.get_plugin then
-      # plugin から import されている場合 gen をサーチパスの先頭に加える
-      search_path = [ $gen ] + $import_path
-    else
-      search_path = $import_path
-    end
-
-    search_path.each{ |path|
-      dbgPrint "import: searching #{path}/#{@cdl}"
-      begin
-        if path == "."
-          cdl_path =  @cdl
-        else
-          cdl_path = "#{path}/#{@cdl}"
-        end
-
-        # ファイルの stat を取ってみる(なければ例外発生)
-        File.stat( cdl_path )
-
-        # cdl を見つかったファイルパスに再設定
-        @cdl_path = cdl_path
+    if( Generator.get_plugin ) &&( File.exist? "#{$gen}/#{@cdl}" ) then
+      @cdl_path = "#{$gen}/#{@cdl}"
+      found = true
+    else
+      path = find_file @cdl
+      if path then
         found = true
-        dbgPrint ": found\n"
-        break
-      rescue => evar
-        found = false
-        dbgPrint ": not found\n"
-        # print_exception( evar )
-      end
-    }
+        @cdl_path = path
+      end
+    end
 
     if found == false then
@@ -7118,46 +7741,37 @@
 end
 
-#== generate: signature プラグインのロードと実行
+#== generate: signature, celltype, cell へのプラグインのロードと適用
 class Generate < Node
 #@plugin_name:: Symbol
-#@signature_nsp:: NamespacePath
+#@object_nsp:: NamespacePath
 #@option::         String '"', '"' で囲まれている
+#@plugin_object:: Plugin
 
   include PluginModule
 
-  def initialize( plugin_name, signature_nsp, option )
+  def initialize( plugin_name, object_nsp, option )
     super()
     @plugin_name = plugin_name
-    @signature_nsp = signature_nsp
+    @object_nsp = object_nsp
     option = option.to_s    # option は Token
     @option = option
-
-    signature = Namespace.find( signature_nsp ) #mikan Namespace   #1
-    if ! signature.instance_of? Signature then
-      cdl_error( "S1149 $1 not signature" , signature_nsp )
+    @plugin_object = nil
+
+    dbgPrint "generate: #{plugin_name} #{object_nsp.to_s} option=#{option}\n"
+
+    object = Namespace.find( object_nsp )
+    if object.kind_of?( Signature ) ||
+       object.kind_of?( Celltype ) ||
+       object.kind_of?( CompositeCelltype ) ||
+       object.kind_of?( Cell )then
+      @plugin_object = object.apply_plugin( @plugin_name, @option )
+    elsif object then
+      # V1.5.0 以前の仕様では、signature のみ可能だった
+#      cdl_error( "S1149 $1 not signature" , signature_nsp )
+      cdl_error( "S9999 generate: '$1' neither signature, celltype nor cell", object_nsp )
       return
-    elsif signature.is_empty? then
-      cdl_warning( "S9999 $1 is empty. cannot apply signature plugin. ignored" , signature_nsp )
-      return
-    end
-
-    load_plugin( plugin_name, SignaturePlugin )
-
-    plugin_object = nil
-    eval_str = "plugin_object = #{plugin_name}.new( signature, option )"
-    if $verbose then
-      print "new through: #{eval_str}\n"
-    end
-
-    begin
-      eval( eval_str )     # plugin を生成
-      plugin_object.set_locale @locale
-    rescue Exception => evar
-      cdl_error( "S1150 $1: fail to new" , plugin_name )
-      print "eval( #{eval_str} )\n"
-
-      print_exception( evar )
-    end
-    generate_and_parse plugin_object
+    else
+      cdl_error( "S9999 generate: '$1' not found", object_nsp )
+    end
   end
 end
Index: EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/ctypes.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/ctypes.rb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/ctypes.rb	(revision 429)
@@ -4,5 +4,5 @@
 #      Generator for TOPPERS Embedded Component System
 #  
-#   Copyright (C) 2008-2014 by TOPPERS Project
+#   Copyright (C) 2008-2017 by TOPPERS Project
 #--
 #   上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
@@ -118,10 +118,13 @@
       end
       return self
-    else
+    elsif self.instance_of?( CFloatType ) then
       # mikan long double
       #   TECS には long double を表現する手段がない (double80_t を定義すればよいか?)
 #      cdl_warning( "C1003 $1 & $2 incompatible (\'long double\' is not supported.). Treated as $3." , self.class, another.class, self.class )
-      cdl_warning( "W9999 $1 & $2 incompatible (\'long double\' is not supported.). Treated as $3." , self.get_type_str, another.get_type_str, self.get_type_str )
-      return self
+#      cdl_warning( "W9999 $1 & $2 incompatible (\'long double\' is not supported.). Treated as $3." , self.get_type_str, another.get_type_str, self.get_type_str )
+      self.to_long      
+      return self
+    else
+      raise "merge: unknown type"
     end
   end
@@ -183,4 +186,11 @@
   end
 
+  def to_long
+    if @bit_size != -64 then
+      cdl_warning( "W9999 long specified for $1" , get_type_str )
+    else
+      @bit_size = -128  # @bit_size = -128 : long double
+    end
+  end
 end
 
Index: EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/expression.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/expression.rb	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/expression.rb	(revision 429)
@@ -4,5 +4,5 @@
 #      Generator for TOPPERS Embedded Component System
 #  
-#   Copyright (C) 2008-2014 by TOPPERS Project
+#   Copyright (C) 2008-2017 by TOPPERS Project
 #--
 #   上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
@@ -151,4 +151,5 @@
     when :IDENTIFIER
       nsp = elements[1]
+      # if nsp.is_name_only? && name_list && name_list.get_item( nsp.get_name ) then
       if nsp.is_name_only? && name_list && name_list.get_item( nsp.get_name ) then
         return "#{pre}#{nsp.get_name}#{post}"
@@ -229,4 +230,111 @@
   end
 
+  #=== Expression# 逆ポーランド文字列化
+  #param_list:: ParamlList  関数の引数リスト
+  def get_rpn( param_list = nil, name_list2 = nil )
+    return elements_rpn( @elements, param_list, name_list2 )
+  end
+
+  #=== Expression# 逆ポーランド文字列化 (private)
+  #name_list:: ParamlList  関数の引数リスト
+  def elements_rpn( elements, name_list = nil, name_list2 = nil )
+    if elements.instance_of? Token then
+      print "rpn: #{elements.to_s}\n"
+      return elements.to_s    # OP_DOT, OP_REF の右辺
+    end
+
+    case elements[0]
+    when :IDENTIFIER
+      nsp = elements[1]
+      #if nsp.is_name_only? && name_list && name_list.find( nsp.get_name ) then
+      if nsp.is_name_only? then
+        count = 0
+        # p "search: #{nsp.get_name}"
+        name_list.get_items.each{ |nm,val|
+          # p "    : #{nm.get_name} #{nsp.get_name.class} #{nm.get_name.class}"
+          if nsp.get_name == nm.get_name then
+            return " $#{count}"
+          end
+          count += 1
+        }
+        raise "not found parameter"
+      else
+        # return  elements[1].get_global_name
+        raise "not unexpected parameter"
+      end
+    when :INTEGER_CONSTANT, :FLOATING_CONSTANT, :OCTAL_CONSTANT, :HEX_CONSTANT, :CHARACTER_LITERAL, :STRING_LITERAL_LIST, :BOOL_CONSTANT
+      return elements[1].to_s
+    when :PARENTHESES
+      return elements_rpn( elements[1], name_list, name_list2 )
+    when :OP_SUBSC
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[1], "", name_list, name_list2 ) + " []"
+    when :OP_DOT
+      return elements_rpn( elements[1], name_list, name_list2 ) + " ."
+    when :OP_REF
+      return elements_rpn( elements[1], name_list, name_list2 ) + " ->"
+    when :OP_SIZEOF_EXPR
+      return elements_rpn( elements[1], name_list, name_list2 ) + " #s"
+    when :OP_SIZEOF_TYPE
+      return elements_rpn( elements[1], name_list, name_list2 ) + " #S"
+    when :OP_U_AMP
+      return elements_rpn( elements[1], name_list, name_list2 ) + " #&"
+    when :OP_U_ASTER
+      return elements_rpn( elements[1], name_list, name_list2 ) + " #*"
+    when :OP_U_PLUS
+      return elements_rpn( elements[1], name_list, name_list2 ) + " #+"
+    when :OP_U_MINUS
+      return elements_rpn( elements[1], name_list, name_list2 ) + " #-"
+    when :OP_U_TILDE
+      return elements_rpn( elements[1], name_list, name_list2 ) + " #~"
+    when :OP_U_EXCLAM
+      return elements_rpn( elements[1], name_list, name_list2 ) + " #!"
+    when :CAST
+      return elements_rpn( elements[1], name_list, name_list2 ) + " #(" + elements_rpn( elements[2], "", name_list, name_list2 ) + ")"
+    when :OP_MULT
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " *"
+    when :OP_DIV
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " /"
+    when :OP_REMAIN
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " %"
+    when :OP_ADD
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " +"
+    when :OP_SUB
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " -"
+    when :OP_LSFT
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " <<"
+    when :OP_RSFT
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " >>"
+    when :OP_LT
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " <"
+    when :OP_GT
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " >"
+    when :OP_LE
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " <="
+    when :OP_GE
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " >="
+    when :OP_EQ
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " =="
+    when :OP_NE
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " !="
+    when :OP_AND
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " &"
+    when :OP_EOR
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " ^"
+    when :OP_OR
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " |"
+    when :OP_LAND
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " &&"
+    when :OP_LOR
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " + elements_rpn( elements[2], "", name_list, name_list2 ) + " ||"
+    when :OP_CEX
+      return elements_rpn( elements[1], name_list, name_list2 ) + " " +
+             elements_rpn( elements[2], name_list, name_list2 ) + " " +
+             elements_rpn( elements[3], name_list, name_list2 ) + " ?:"
+    else
+      raise "Unknown expression element: #{elemets[0]}. try -t and please report"
+    end
+    return ""
+  end
+
   # 定数式(elements)を評価する
   #
@@ -382,8 +490,16 @@
       return nil
     when :OP_SIZEOF_EXPR
-      cdl_error( "E1007 cannot evaluate \'sizeof\' operator"  )
+      if Generator.parsing_C? then
+        cdl_info( "I9999 cannot evaluate \'sizeof\' operator. this might causes later error."  )
+      else
+        cdl_error( "E1007 cannot evaluate \'sizeof\' operator"  )
+      end
       return nil
     when :OP_SIZEOF_TYPE
-      cdl_error( "E1008 cannot evaluate \'sizeof\' operator"  )
+      if Generator.parsing_C? then
+        cdl_info( "I9999 cannot evaluate \'sizeof\' operator. this might causes later error."  )
+      else
+        cdl_error( "E1008 cannot evaluate \'sizeof\' operator"  )
+      end
       return nil
     when :OP_U_AMP
